/*
 * n_utilities.c
 *
 *  Created on: Nov 6, 2015
 *      Author: neilh77
 */

#include <stdio.h>
#include <string.h>
#include <stdarg.h>
#include <errno.h>

#include "main.h"
#include "n_ttyQueue.h"

UART_HandleTypeDef uhDebugUart;
__IO ITStatus UartDebugTxReady = RESET;
__IO ITStatus UartDebugRxReady = RESET;




HAL_StatusTypeDef dbg_putchar(const uint8_t ch);
void console_deinit() {

}
// UART init ..... uhDebugUart


//HAL_StatusTypeDef dbg_putchar(const uint8_t ch) {
//	return HAL_UART_Transmit(&uhDebugUart, (uint8_t*)&ch, 1, 100);
//}
HAL_StatusTypeDef ttyHalPutc( uint8_t ch) {
	return HAL_UART_Transmit_IT(&uhDebugUart, &ch, 1);
}
HAL_StatusTypeDef ttyHalPuts(uint8_t *chStr) {
	return HAL_UART_Transmit_IT(&uhDebugUart, chStr,  strlen(chStr));
}


/**
  * @brief  Tx Transfer completed callback
  * @param  UartHandle: UART handle.
  * @note   This example shows a simple way to report end of IT Tx transfer, and
  *         you can add your own implementation.
  * @retval None
  */
void HAL_UART_TxCpltCallback(UART_HandleTypeDef *huart)
//void HAL_UART_TxCpltCallback(UART_HandleTypeDef *UartHandle)
{
  /* Set transmission flag: transfer complete */
	//IS_UART_INSTANCE(huart->Instance)
	if (USART1 == (huart->Instance)) {
		UartDebugTxReady = SET;
		ttyQueue_putDone();
	} else {
	//default: prototype leave turd
		UartDebugTxReady = 0x1234;
	}

  /* Turn LED6 on: Transfer in transmission process is correct */
  //BSP_LED_On(LED6);
}

/**
  * @brief  Rx Transfer completed callback
  * @param  UartHandle: UART handle
  * @note   This example shows a simple way to report end of IT Rx transfer, and
  *         you can add your own implementation.
  * @retval None
  */
void HAL_UART_RxCpltCallback(UART_HandleTypeDef *UartHandle)
{
  /* Set transmission flag: transfer complete */

  UartDebugRxReady = SET;


  /* Turn LED4 on: Transfer in reception process is correct */
  //BSP_LED_On(LED4);
}

/**
  * @brief  UART error callbacks
  * @param  UartHandle: UART handle
  * @note   This example shows a simple way to report transfer error, and you can
  *         add your own implementation.
  * @retval None
  */
 void HAL_UART_ErrorCallback(UART_HandleTypeDef *UartHandle)
{
  /* Turn LED3 on: Transfer error in reception/transmission process */
  //BSP_LED_On(LED3);
}
inline void dbgUART_IRQHandler(void) {

 HAL_UART_IRQHandler(&uhDebugUart);
}



